clear
clc
addpath(genpath('functions_dataread'))
addpath(genpath('matrices'))
load panel_close_daily;

% convert daily data into 4 week a month
date_daily = panel_close(2:end,1);
data_daily = panel_close(2:end,2:end);
contracts_all = panel_close(1,2:end);

m_begin = 199001; m_end = 201106;

[date_weekly,panel_close_weekly,contracts,week_index] = daily_to_pseudoweekly_expiry(date_daily,contracts_all, data_daily,m_begin, m_end); 

%% translate weekly price panel aligned with contracts to monthly panel for week j = 1, 2, 3, 4, aligned with maturity in month (0,1,..,m)
% Note, we use log price here
% calculate y1 and y2 for j = 1,2,3,4

m = 2; % takes month 0,1,...,m

% j = 1 
j = 1;
y1_matu = log(convert_contr2matu(panel_close_weekly,week_index,j,m));
% j = 2 
j = 2;
y2_matu = log(convert_contr2matu(panel_close_weekly,week_index,j,m));
% j = 3 
j = 3;
y3_matu = log(convert_contr2matu(panel_close_weekly,week_index,j,m));
% j = 4 
j = 4;
y4_matu = log(convert_contr2matu(panel_close_weekly,week_index,j,m));

date1 = date_weekly(1:4:length(date_weekly)-8);
date2 = date_weekly(2:4:length(date_weekly)-8);
date3 = date_weekly(3:4:length(date_weekly)-8);
date4 = date_weekly(4:4:length(date_weekly)-8);
%save('panel_close_weekly_matu_9001to1106.mat','y1_matu','y2_matu','y3_matu','y4_matu','date1','date2','date3','date4')