clear
clc
close all
addpath(genpath('functions_estimation'))
addpath(genpath('matrices'))

load panel_close_weekly_matu_9001to1106

%===================================================
%If you run this section, it produces Figure 5 and 6
tt = [1,180];
load parameters_base_90to04
%===================================================

%===================================================
%If you run this section, it produces Figure 7 and 8
% tt = [181,256];
% load parameters_base_05to11
%===================================================


%% calculate y1 and y2 for each j
%P1 = [1/3, 1/3, 1/3; -1, 0, 1];
P1 = [0 (1/2) (1/2); 0 -1 1];
P2 = [1 0 0];
% j = 1 
y11 = y1_matu(tt(1):tt(2),:)*P1';% notation yj,i, where j = 1,2,3,4 week, and i = 1,2 % NOTE, the notation for A and B reverse order!
y12 = y1_matu(tt(1):tt(2),:)*P2';
% j = 2 
y21 = y2_matu(tt(1):tt(2),:)*P1';
y22 = y2_matu(tt(1):tt(2),:)*P2';
% j = 3 
y31 = y3_matu(tt(1):tt(2),:)*P1';
y32 = y3_matu(tt(1):tt(2),:)*P2';
% j = 4 
y41 = y4_matu(tt(1):tt(2),:)*P1';
y42 = y4_matu(tt(1):tt(2),:)*P2';




[penalty,phi1,Phi1,Omega1,phi2,Phi2,Omega2,phi3,Phi3,Omega3,phi4,Phi4,Omega4,...
    gamma1, Gamma1,gamma2, Gamma2,gamma3, Gamma3,gamma4, Gamma4,A1,A2,A3,A4,B1,B2,B3,B4,cQ,rhoQ,beta_0,alpha,beta_transpose]...
    = papa_str2redu(xi,Sigma, c, rho, alpha_0,P1,P2);
para1_(:,:,1) = [phi1';Phi1'];
para1_(:,:,2) = [phi2';Phi2'];
para1_(:,:,3) = [phi3';Phi3'];
para1_(:,:,4) = [phi4';Phi4'];

para2_(:,:,1) = [gamma1';Gamma1'];
para2_(:,:,2) = [gamma2';Gamma2'];
para2_(:,:,3) = [gamma3';Gamma3'];
para2_(:,:,4) = [gamma4';Gamma4'];

Omega_(:,:,1) = ltvec(Omega1);
Omega_(:,:,2) = ltvec(Omega2);
Omega_(:,:,3) = ltvec(Omega3);
Omega_(:,:,4) = ltvec(Omega4);



%{
load parameters_seasonal_xi_invariant_after05
[penalty,Omega,gamma,Gamma,alpha,beta_transpose,cQ]...
    = papa_str2redu_seasonal_xi_invariant(xi,alpha_0,Sigma,P1,P2);
for i = 1:4
    para2_(:,:,i) = [gamma(:,:,i)';Gamma(:,:,i)'];
end
%}

%% OLS regressions

% j = 1
[coeff,~,stats] = ols_(y11(2:end,:),y41(1:end-1,:));
para1(:,:,1) = coeff.b;
para1_std (:,:,1) = stats.std_b;
Omega(:,:,1) = ltvec(coeff.Omega);
Omega_std(:,:,1) = ltvec(stats.std_Omega);


% j = 2
[coeff,~,stats] = ols_(y21(2:end,:),y11(2:end,:));
para1(:,:,2) = coeff.b;
para1_std (:,:,2) = stats.std_b;
Omega(:,:,2) = ltvec(coeff.Omega);
Omega_std(:,:,2) = ltvec(stats.std_Omega);


% j = 3
[coeff,~,stats] = ols_(y31(2:end,:),y21(2:end,:));
para1(:,:,3) = coeff.b;
para1_std (:,:,3) = stats.std_b;
Omega(:,:,3) = ltvec(coeff.Omega);
Omega_std(:,:,3) = ltvec(stats.std_Omega);


% j = 4
[coeff,~,stats] = ols_(y41(2:end,:),y31(2:end,:));
para1(:,:,4) = coeff.b;
para1_std (:,:,4) = stats.std_b;
Omega(:,:,4) = ltvec(coeff.Omega);
Omega_std(:,:,4) = ltvec(stats.std_Omega);


% second, estimate the y2 equation to solve for gamma, Gamma, and
% calculate information matrix
% j = 1
[coeff,~,stats] = ols_(y12(2:end,:),y11(2:end,:));
para2(:,:,1) = coeff.b;
para2_std (:,:,1) = stats.std_b;

% j = 2
[coeff,~,stats] = ols_(y22(2:end,:),y21(2:end,:));
para2(:,:,2) = coeff.b;
para2_std (:,:,2) = stats.std_b;

% j = 3
[coeff,~,stats] = ols_(y32(2:end,:),y31(2:end,:));
para2(:,:,3) = coeff.b;
para2_std (:,:,3) = stats.std_b;

% j = 4
[coeff,~,stats] = ols_(y42(2:end,:),y41(2:end,:));
para2(:,:,4) = coeff.b;
para2_std (:,:,4) = stats.std_b;


[M N] = size(para1(:,:,1));
i = 0;
names = cell(3,2);
names{1,1} = '\phi_1';
names{1,2} = '\phi_2';
names{2,1} = '\Phi_1_1';
names{2,2} = '\Phi_2_1';
names{3,1} = '\Phi_1_2';
names{3,2} = '\Phi_2_2';

for m = 1:M
    for n = 1:N
        i = i+1;
        subplot(M,N,i)
        plot(reshape(para1(m,n,:),4,1)), hold on
        plot([reshape(para1(m,n,:)-2*para1_std(m,n,:),4,1) reshape(para1(m,n,:)+2*para1_std(m,n,:),4,1)],'b--')
        plot(reshape(para1_(m,n,:),4,1),'r','linewidth',2)
        %title(['para1, row ' num2str(m) ', column ' num2str(n)])
        title(names{m,n})
    end
end



[M N] = size(Omega(:,:,1));
names = cell(3,2);
names{1,1} = '\Omega_1_1';
names{2,1} = '\Omega_2_1';
names{3,1} = '\Omega_2_2';
index = [1,3,5,2,4,6];
figure
i = 0;
for m = 1:M
    for n = 1:N
        i = i+1;
        subplot(3,2,index(i))
        plot(reshape(Omega(m,n,:),4,1)), hold on
        plot([reshape(Omega(m,n,:)-2*Omega_std(m,n,:),4,1) reshape(Omega(m,n,:)+2*Omega_std(m,n,:),4,1)],'b--')
        plot(reshape(Omega_(m,n,:),4,1),'r','linewidth',2)
        %title(['para1, row ' num2str(m) ', column ' num2str(n)])
        title(names{m,1})
    end
end


[M N] = size(para2(:,:,1));
names{1,2} = '\gamma';
names{2,2} = '\Gamma_1';
names{3,2} = '\Gamma_2';

for m = 1:M
    for n = 1:N
        i = i+1;
        subplot(3,2,index(i))
        plot(reshape(para2(m,n,:),4,1)), hold on
        plot([reshape(para2(m,n,:)-2*para2_std(m,n,:),4,1) reshape(para2(m,n,:)+2*para2_std(m,n,:),4,1)],'b--')
        plot(reshape(para2_(m,n,:),4,1),'r','linewidth',2)
        title(names{m,2})
    end
end
%saveas(gcf,'omega_gamma_after05.eps')
%saveas(gcf,'omega_gamma_after05.pdf')