% In this specification, we define H1 * [f0t, f4t, f8t]' as factors, and assume
% H1 * yt priced exactly. See hw4_20110813
clear
clc
addpath(genpath('functions_estimation'))
addpath(genpath('matrices'))

load panel_close_weekly_matu_9001to1106

%=========================================================
%If you run this section, it produces estimates in Table 5
tt = [1,180];
%=========================================================

%=========================================================
%If you run this section, it produces estimates in Table 6
% tt = [181,256];
%=========================================================

%% calculate y1 and y2 for each j
%P1 = [1/3, 1/3, 1/3; -1, 0, 1];
P1 = [0 (1/2) (1/2); 0 -1 1];
P2 = [1 0 0];
% j = 1 
y11 = y1_matu(tt(1):tt(2),:)*P1';% notation yj,i, where j = 1,2,3,4 week, and i = 1,2 % NOTE, the notation for A and B reverse order!
y12 = y1_matu(tt(1):tt(2),:)*P2';
% j = 2 
y21 = y2_matu(tt(1):tt(2),:)*P1';
y22 = y2_matu(tt(1):tt(2),:)*P2';
% j = 3 
y31 = y3_matu(tt(1):tt(2),:)*P1';
y32 = y3_matu(tt(1):tt(2),:)*P2';
% j = 4 
y41 = y4_matu(tt(1):tt(2),:)*P1';
y42 = y4_matu(tt(1):tt(2),:)*P2';

%% OLS regressions
% first, estimate the y1 equations to solve phi, Phi and Omega, and
% calculate information matrix
Omega = zeros(2,2,4);
H1 = zeros(6,6,4);
H1v = zeros(3,3,4);
H2 = zeros(3,3,4);
% j = 1
[phi(:,:,1),Phi(:,:,1),Omega(:,:,1)] = ols(y11(2:end,:),y41(1:end-1,:),1);
[H1(:,:,1), H1v(:,:,1)] = information_matrix(y41(1:end-1,:),Omega(:,:,1),1);
% j = 2
[phi(:,:,2),Phi(:,:,2),Omega(:,:,2)] = ols(y21(2:end,:),y11(2:end,:),1);
[H1(:,:,2), H1v(:,:,2)] = information_matrix(y11(2:end,:),Omega(:,:,2),1);
% j = 3
[phi(:,:,3),Phi(:,:,3),Omega(:,:,3)] = ols(y31(2:end,:),y21(2:end,:),1);
[H1(:,:,3), H1v(:,:,3)] = information_matrix(y21(2:end,:),Omega(:,:,3),1);
% j = 4
[phi(:,:,4),Phi(:,:,4),Omega(:,:,4)] = ols(y41(2:end,:),y31(2:end,:),1);
[H1(:,:,4), H1v(:,:,4)] = information_matrix(y31(2:end,:),Omega(:,:,4),1);
% second, estimate the y2 equation to solve for gamma, Gamma, and
% calculate information matrix
% j = 1
[gamma(:,:,1), Gamma(:,:,1),Sigma_e1] = ols(y12(2:end,:),y11(2:end,:),1);
% j = 2
[gamma(:,:,2), Gamma(:,:,2),Sigma_e2] = ols(y22(2:end,:),y21(2:end,:),1);
% j = 3
[gamma(:,:,3), Gamma(:,:,3),Sigma_e3] = ols(y32(2:end,:),y31(2:end,:),1);
% j = 4
[gamma(:,:,4), Gamma(:,:,4),Sigma_e4] = ols(y42(2:end,:),y41(2:end,:),1);

% calculate hessians
[H2(:,:,1)] = information_matrix(y11(2:end,:),Sigma_e1,1);
[H2(:,:,2)] = information_matrix(y21(2:end,:),Sigma_e2,1);
[H2(:,:,3)] = information_matrix(y31(2:end,:),Sigma_e3,1);
[H2(:,:,4)] = information_matrix(y41(2:end,:),Sigma_e4,1);

%% MCS estimation
options  =  optimset('fminunc');
options  =  optimset(options , 'TolFun'      , 1e-20);
options  =  optimset(options , 'TolX'      , 1e-15);
options  =  optimset(options , 'Display'     , 'iter');
options  =  optimset(options , 'Diagnostics' , 'on');
options  =  optimset(options , 'LargeScale'  , 'off');
options  =  optimset(options , 'MaxIter' , 5000) ;
options  =  optimset(options , 'MaxFunEvals' , 50000) ;


% initial condition
%{
J = 4;
Sigma_ini = zeros(2,2,J);

for j = 1:J
    %Sigma_ini(:,:,j) = chol(mean(Omega,3))';
    Sigma_ini(:,:,j) = Sigma;
end

parameters = para_ind2vec_HW4_seasonal_xi_invariant(xi,Sigma_ini,alpha_0);
%}

load parameters_seasonal_90to04
% load parameters_seasonal_05to11

parameters = para_ind2vec_HW4_seasonal_xi_invariant(xi,Sigma,alpha_0);

for j = 1:3
    initial = parameters;
    [parameters,F] =  fminunc('MCS_HW4_seasonal_xi_invariant',initial, options,...
        Omega,gamma,Gamma,H1v,H2,P1,P2);
end

[xi,Sigma,alpha_0] = para_vec2ind_HW4_seasonal_xi_invariant(parameters);
[F,alpha,beta_transpose,cQ,rhoQ] = MCS_HW4_seasonal_xi_invariant(parameters,Omega,gamma,Gamma,H1v,H2,P1,P2);

% solve c and rho analytically
J =4;
rho = zeros(2,2,J);
c = zeros(2,1,J);
for j = 1: J
    Bj = [beta_transpose(4-j+1,:);beta_transpose(8-j+1,:);beta_transpose(12-j+1,:)];
    Aj = [alpha(4-j+1,:);alpha(8-j+1,:);alpha(12-j+1,:)];
    
    if j==1
        Bjmius1 = [beta_transpose(0+1,:);beta_transpose(4+1,:);beta_transpose(8+1,:)];
        Ajmius1 = [alpha(0+1,:);alpha(4+1,:);alpha(8+1,:)];
    else
        Bjmius1 = [beta_transpose(5-j+1,:);beta_transpose(9-j+1,:);beta_transpose(13-j+1,:)];
        Ajmius1 = [alpha(5-j+1,:);alpha(9-j+1,:);alpha(13-j+1,:)];
    end   
    rho(:,:,jplusi(j,-1)) = (P1*Bj)\Phi(:,:,j)*(P1*Bjmius1);
    c(:,:,jplusi(j,-1)) = (P1*Bj)\(phi(:,:,j)-P1*Aj+Phi(:,:,j)*P1*Ajmius1);
end


%save('parameters_seasonal_90to04','xi','Sigma','alpha_0','c','rho')
%save('parameters_seasonal_05to11','xi','Sigma','alpha_0','c','rho')
%save('parameters_seasonal_90to11','xi','Sigma','alpha_0','c','rho')



for i = 1:4
    lam(:,:,i) = c(:,:,i)-cQ;
    LAM(:,:,i) = rho(:,:,i) - rhoQ;
end

% check with full MCS
parameters = para_ind2vec_HW4_seasonal_xi_invariant_full(xi,Sigma,alpha_0,c,rho);
[F,alpha,beta_transpose,cQ,rhoQ] = MCS_HW4_seasonal_xi_invariant_full(parameters,phi,Phi,Omega,gamma,Gamma,H1,H1v,H2,P1,P2);
%% calculate asymptotic standard errors
addpath(genpath('functions_asymptoticSTD'))
R = [];
for j = 1:4
    R = blkdiag(R,H1(:,:,j), H1v(:,:,j),H2(:,:,j));
end

GAMMA = numgrad('papa_str2redu_vec_seasonal',parameters,P1,P2);
variance = inv(GAMMA'*R*GAMMA);
para_std = sqrt(diag(variance));
[xi_std,Sigma_std,alpha_0_std,c_std, rho_std] =  para_vec2ind_HW4_seasonal_xi_invariant_full(para_std);

parameters2 = para_ind2vec_HW4_seasonal_xi_invariant_full(xi,Sigma,alpha_0,lam,LAM);
GAMMA = numgrad('papa_str2redu_vec_lam_seasonal',parameters2,P1,P2);
variance = inv(GAMMA'*R*GAMMA);
para_std = sqrt(diag(variance));
[xi_std,Sigma_std,alpha_0_std,lam_std, LAM_std] =  para_vec2ind_HW4_seasonal_xi_invariant_full(para_std);
