function paraRED_vec = papa_str2redu_vec_lam_seasonal(paraSTR_vec,H1,H2)

N = 2; J = 4;
G = zeros(J);
G(1,2) = 1; G(2,3) = 1; G(3,4) = 1; G(4,1) = 1;

[xi,Sigma,alpha_0,lam,LAM] = para_vec2ind_HW4_seasonal_xi_invariant_full(paraSTR_vec);
%=========================create sigma*sigma'==============================
for j = 1:J
    Sigma_sq(:,:,j) = Sigma(:,:,j)*Sigma(:,:,j)';
     %eval(['Sigma' num2str(j) '_sq' ' = Sigma.j' num2str(j) '*Sigma.j' num2str(j) ';'])
end

%====================CALCULATE rhoQ_j, beta_0==============================
K_xi = [xi.^0,xi.^4,xi.^8];
rhoQ = ((K_xi*H1')\diag(xi)*(K_xi*H1'))';
beta_0 = (K_xi*H1')\ones(2,1);

%==========================calculate beta==================================
beta_transpose = zeros(12,2);  % ith row of beta_transpose is beta_i-1'
beta_transpose(1,:) = beta_0';
for i = 2:12
    beta_transpose(i,:) = beta_transpose(i-1,:)*rhoQ;
end

%============================calculate cQ==================================
psi_0 = alpha_0;
psi_4 = alpha_0;
psi_8 = alpha_0;

for n = 1:4
    psi_4 = psi_4 + 1/2*beta_transpose(n,:)*Sigma_sq(:,:,jplusi (12, -n))*beta_transpose(n,:)';
end

for n = 1:8
    psi_8 = psi_8 + 1/2*beta_transpose(n,:)*Sigma_sq(:,:,jplusi (12, -n))*beta_transpose(n,:)';
end

cQ = -(H1*[zeros(1,2);sum(beta_transpose(1:4,:));sum(beta_transpose(1:8,:))])\...
    (H1*[psi_0;psi_4;psi_8]);

%==========================================================================


for i = 1:4
    c(:,:,i) = cQ+lam(:,:,i);
    rho(:,:,i) = rhoQ+LAM(:,:,i);
end
%==========================calculate alpha=================================
alpha = zeros(12,1);
alpha(1) = alpha_0;
for i = 2:12
    %alpha(i) = alpha(i-1)+beta_transpose(i-1,:)*cQ + 0.5 * beta_sigsig_beta(i-1);
    alpha(i) = alpha(i-1)+beta_transpose(i-1,:)*cQ + 0.5 * beta_transpose(i-1,:)*Sigma_sq(:,:,jplusi (12, -i+1))*beta_transpose(i-1,:)';
end

%==================convert to reduced form parameters======================
Omega = zeros(N,N,J);
Gamma = zeros(1,N,J);
gamma = zeros(1,1,J);

for j = 1: J
    Bj = [beta_transpose(4-j+1,:);beta_transpose(8-j+1,:);beta_transpose(12-j+1,:)];
    %Aj = [alpha(4-j+1,:,j);alpha(8-j+1,:,j);alpha(12-j+1,:,j)];
    Aj = [alpha(4-j+1,:);alpha(8-j+1,:);alpha(12-j+1,:)];
    
    if j==1
        Bjmius1 = [beta_transpose(0+1,:);beta_transpose(4+1,:);beta_transpose(8+1,:)];
        %Ajmius1 = [alpha(0+1,:,4);alpha(4+1,:,4);alpha(8+1,:,4)];
        Ajmius1 = [alpha(0+1,:);alpha(4+1,:);alpha(8+1,:)];
    else
        Bjmius1 = [beta_transpose(5-j+1,:);beta_transpose(9-j+1,:);beta_transpose(13-j+1,:)];
        %Ajmius1 = [alpha(5-j+1,:,jplusi(j,-1));alpha(9-j+1,:,jplusi(j,-1));alpha(13-j+1,:,jplusi(j,-1))];
        Ajmius1 = [alpha(5-j+1,:);alpha(9-j+1,:);alpha(13-j+1,:)];
    end      

    Omega(:,:,j) = H1*Bj*Sigma_sq(:,:,jplusi(j,-1))*(H1*Bj)'; 
    Phi(:,:,j) = H1*Bj*rho(:,:,jplusi(j,-1))/(H1*Bjmius1);
    Gamma(:,:,j) = (H2*Bj)/(H1*Bj);
    gamma(:,:,j) = H2*Aj - Gamma(:,:,j)*H1*Aj;
    phi(:,:,j) = H1*Aj + H1*Bj*c(:,:,jplusi(j,-1)) - Phi(:,:,j)*H1*Ajmius1;

end


paraRED_vec = [];
for j = 1:J
    temp1 = [phi(:,:,j)';Phi(:,:,j)'];
    temp2 = [gamma(:,:,j)';Gamma(:,:,j)'];
    paraRED_vec = [paraRED_vec;temp1(:);ltvec(Omega(:,:,j));temp2(:)];
end


