function y_j_matu = convert_contr2matu(panel_close_weekly,week_index,j,m)
% function convert_contr2matu converts weekly panel aligned by contract to
% monthly panel of jth week aligned by maturity
% INPUTS:   panel_close_weekly: original weekly panel aligned by contracts
%           j: week index,  j = 1: week 1 
%                           j = 2: week 2
%                           j = 3: week 3 
%                           j = 4: week 4
%               weeks are defined in daily_to_pseudoweekly_expiry or
%               daily_to_pseudoweekly, depending which function we use
%           m: how many months to be included. Maturity goes from 0, 1,
%                           ..., m
% OUTPUTS:  y_j_matu: monthly panel of ith week aligned by maturity

y_j_contr = panel_close_weekly(week_index == j,:);
T = size(y_j_contr,1);

y_j_matu = zeros(T-m, m+1);

for i = 1: T-m
    y_j_matu(i,:) = y_j_contr(i, i: i+m);
end
