function [F,A1,A2,A3,A4,B1,B2,B3,B4,cQ,rhoQ,beta_0,alpha,beta_transpose] = MCS_HW4(parameters,phi1,Phi1,Omega1,phi2,Phi2,Omega2,phi3,Phi3,Omega3,phi4,Phi4,Omega4,...
    gamma1, Gamma1,gamma2, Gamma2,gamma3, Gamma3,gamma4, Gamma4,...
    H_11, Hv_11,H_12, Hv_12,H_13, Hv_13,H_14, Hv_14,...
    H_21, H_22, H_23,H_24,P1,P2)
% MCSE_HW4 calculates MCS statistic based on

[xi,alpha_0,c, rho,Sigma] = para_vec2ind_HW4(parameters);  

[penalty,phi1_res,Phi1_res,Omega1_res,phi2_res,Phi2_res,Omega2_res,phi3_res,Phi3_res,Omega3_res,phi4_res,Phi4_res,Omega4_res,...
    gamma1_res, Gamma1_res,gamma2_res, Gamma2_res,gamma3_res, Gamma3_res,gamma4_res, Gamma4_res,A1,A2,A3,A4,B1,B2,B3,B4,cQ,rhoQ,beta_0,alpha,beta_transpose]...
    = papa_str2redu(xi,Sigma, c, rho, alpha_0,P1,P2);  

if penalty > 0
    F = panelty;
else
    % for the y1 part
    diff_11 = [phi1';Phi1'] - [phi1_res';Phi1_res'];      
    F_11 = diff_11(:)'*H_11*diff_11(:);
    Fv_11 = ltvec(Omega1 - Omega1_res)'*Hv_11*ltvec(Omega1 - Omega1_res);

    diff_12 = [phi2';Phi2'] - [phi2_res';Phi2_res'];      
    F_12 = diff_12(:)'*H_12*diff_12(:);
    Fv_12 = ltvec(Omega2 - Omega2_res)'*Hv_12*ltvec(Omega2 - Omega2_res);

    diff_13 = [phi3';Phi3'] - [phi3_res';Phi3_res'];      
    F_13 = diff_13(:)'*H_13*diff_13(:);
    Fv_13 = ltvec(Omega3 - Omega3_res)'*Hv_13*ltvec(Omega3 - Omega3_res);

    diff_14 = [phi4';Phi4'] - [phi4_res';Phi4_res'];      
    F_14 = diff_14(:)'*H_14*diff_14(:);
    Fv_14 = ltvec(Omega4 - Omega4_res)'*Hv_14*ltvec(Omega4 - Omega4_res);

    % for the y2 part
    diff_21 = [gamma1';Gamma1'] - [gamma1_res';Gamma1_res'];      
    F_21 = diff_21(:)'*H_21*diff_21(:);

    diff_22 = [gamma2';Gamma2'] - [gamma2_res';Gamma2_res'];      
    F_22 = diff_22(:)'*H_22*diff_22(:);

    diff_23 = [gamma3';Gamma3'] - [gamma3_res';Gamma3_res'];      
    F_23 = diff_23(:)'*H_23*diff_23(:);
    
    diff_24 = [gamma4';Gamma4'] - [gamma4_res';Gamma4_res'];      
    F_24 = diff_24(:)'*H_24*diff_24(:);

    F = F_11+Fv_11+F_12+Fv_12+F_13+Fv_13+F_14+Fv_14+F_21+F_22+F_23+F_24;
    F_11+F_12+F_13+F_14;
    Fv_11+Fv_12+Fv_13+Fv_14;
    F_21+F_22+F_23+F_24;
end