function [alpha,beta_transpose] = ab_baseline(cQ, rhoQ, Sigma, alpha_0,beta_0)

Sigma_sq = Sigma*Sigma';

beta_transpose = zeros(12,2);  % ith row of beta_transpose is beta_i-1'
beta_transpose(1,:) = beta_0';
for i = 2:12
    beta_transpose(i,:) = beta_transpose(i-1,:)*rhoQ;
end

beta_sigsig_beta = zeros(12,1);
for i = 1:12
    beta_sigsig_beta(i) = beta_transpose(i,:)*Sigma_sq*beta_transpose(i,:)';
end

alpha = zeros(12,1);
alpha(1) = alpha_0;
for i = 2:12
    alpha(i) = alpha(i-1)+beta_transpose(i-1,:)*cQ + 0.5 * beta_sigsig_beta(i-1);
end