function [F,alpha,beta_transpose,cQ,rhoQ,beta_0] = MCS_HW4_seasonal_xi_invariant(parameters,Omega,gamma,Gamma,H1v,H2,P1,P2)
% MCSE_HW4 calculates MCS statistic for seasonal model
% INPUT:    parameters: a vector of structural parameters
%           phi,Phi,Omega,gamma,Gamma: reduced form parameters in 3d matrix
%               where para(:,:,j) = para_j
%           H1,H1v,H2: Hessian/information matrix in 3d matrix where 
%               para(:,:,j) = para_j

J = 4;

[xi,Sigma,alpha_0] = para_vec2ind_HW4_seasonal_xi_invariant(parameters);  
  
[penalty,Omega_res,gamma_res,Gamma_res,alpha,beta_transpose,cQ,rhoQ,beta_0] = papa_str2redu_seasonal_xi_invariant(xi,alpha_0,Sigma,P1,P2);

if penalty > 0
    F = panelty;
else
    % for the y1 part
    F2 = 0;
    F1v = 0;
    
    for j = 1:J
        F1v = F1v + ltvec(Omega(:,:,j) - Omega_res(:,:,j))'*H1v(:,:,j)*ltvec(Omega(:,:,j) - Omega_res(:,:,j));
        diff2 = [gamma(:,:,j)';Gamma(:,:,j)'] - [gamma_res(:,:,j)';Gamma_res(:,:,j)']; 
        F2 = F2 + diff2(:)'*H2(:,:,j)*diff2(:);
    end    
    F = F1v+F2;
end