function [F,alpha,beta_transpose,cQ,rhoQ] = MCS_HW4_seasonal_xi_invariant_full(parameters,phi,Phi,Omega,gamma,Gamma,H1,H1v,H2,P1,P2)
% MCSE_HW4 calculates MCS statistic for seasonal model
% INPUT:    parameters: a vector of structural parameters
%           phi,Phi,Omega,gamma,Gamma: reduced form parameters in 3d matrix
%               where para(:,:,j) = para_j
%           H1,H1v,H2: Hessian/information matrix in 3d matrix where 
%               para(:,:,j) = para_j

J = 4;

[xi,Sigma,alpha_0,c,rho] = para_vec2ind_HW4_seasonal_xi_invariant_full(parameters);  
  
[penalty,phi_res,Phi_res,Omega_res,gamma_res,Gamma_res,alpha,beta_transpose,cQ,rhoQ] = papa_str2redu_seasonal_xi_invariant_full(xi,alpha_0,Sigma,c,rho,P1,P2);

if penalty > 0
    F = panelty;
else
    % for the y1 part
    F1 = 0;
    F2 = 0;
    F1v = 0;
    
    for j = 1:J
        diff1 = [phi(:,:,j)';Phi(:,:,j)'] - [phi_res(:,:,j)';Phi_res(:,:,j)'];
        F1 = F1 + diff1(:)'*H1(:,:,j)*diff1(:);     
        F1v = F1v + ltvec(Omega(:,:,j) - Omega_res(:,:,j))'*H1v(:,:,j)*ltvec(Omega(:,:,j) - Omega_res(:,:,j));
        diff2 = [gamma(:,:,j)';Gamma(:,:,j)'] - [gamma_res(:,:,j)';Gamma_res(:,:,j)']; 
        F2 = F2 + diff2(:)'*H2(:,:,j)*diff2(:);
    end    
    F = F1+F1v+F2;
end