function [xi,Sigma,alpha_0,c,rho] = para_vec2ind_HW4_seasonal_xi_invariant_full(parameters) 
% para_vec2ind_HW4_seasonal converts a vector of parameters into individual 
% parameters for the structural parameters for the seasonal case in HW4.
%
% OUTPUT:   xi, Sigma, alpha_0: 3d parameters, where para(:,:,j) = para_j
%           c,rho: parameters which are j-independent
%
% NOTE, an alternative parameterization (xi,Sigma,alpha_0,lam,Lam) applies
% too!

N = 2;
J = 4;

Sigma = zeros(N,N,J);
c = zeros(N,1,J);
rho = zeros(N,N,J);
xi = parameters(1:2);

for j = 1:J    
    n = N*(N+1)/2;
    Sigma(:,:,j) = veclt(parameters(2 + (j-1)*n + 1 : 2 + j*n))/10;
    n_ind = 2 + J*n;
    
    n = N;
    c(:,:,j) = parameters(n_ind + (j-1)*n+1:n_ind+ j*n)/10;
    n_ind = n_ind + J*n;
    
    n = N^2;
    rho(:,:,j) = reshape(parameters(n_ind + (j-1)*n+1:n_ind+ j*n),N,N);
    n_ind = n_ind + J*n;
end

alpha_0 = parameters(n_ind+ 1)/10;



